<?php
class Google {
	
	public $browser;
	public $parser;
	public $gate_api;
	public $use_proxy = false;
	
	public $ya_xml = '';
	public $browser_ya_xml = false;
	
	public function __construct($gate_api='') {
		global $settings;
		
		$this->browser = new Curl(true, true, false);
		$this->browser->set_sleep(2,5);
		
		if ( $settings->proxy_link || $settings->proxy_list ){
			$proxy_list = false;
			$proxy_link = $settings->proxy_link;
			if ( $proxy_link ) @$proxy_list = file_get_contents($proxy_link);
			if ( !$proxy_list ) $proxy_list = $settings->proxy_list;
			if ( $proxy_list ) $proxy_list = explode("\n", $proxy_list);
			if ( !$proxy_list ) $proxy_list = array();
			$proxy_auth = $settings->proxy_auth;
			if ( $proxy_list ) $this->browser->use_proxy($proxy_list, false, $proxy_auth);
			$this->use_proxy = true;
		}
		
		$this->parser = new Parser();
		$this->gate_api = $gate_api;
		
		
		if ( $settings->ya_xml ) {
			$this->ya_xml = $settings->ya_xml;
			$this->browser_ya_xml = new Curl(true, false, false);
			$this->browser_ya_xml->set_sleep(1,1);
		}
	}
	
	public function get_indexed($site) {
		$domain = str_replace(array('http://', 'https://', '/', ' '), '', $site);
		$query = "site:$domain";
		$query = urlencode($query);
		
		$html = $this->browser->get_page("http://www.google.com/search?oe=utf8&ie=utf8&source=uds&start=0&hl=en&q=$query", '',false, false, false, true);
		
		if($this->use_proxy){
			for($i=0; $i <= 5; $i++) {
				if ( !$html  || strpos($html, 'Google')===false ){
					if ( $i > 1 ) sleep(3);
					$html = $this->browser->get_page("http://www.google.com/search?oe=utf8&ie=utf8&source=uds&start=0&hl=en&q=$query", '',false, false, false, true);
				}
			}
		}
		
		if ( strpos($html, 'document.getElementById(\'captcha\')')!==false ) {
			
			$id = $this->parser->parse_string($html, '|type="hidden" name="id" value="(.*?)"|i');
			$submit = $this->parser->parse_string($html, '|type="submit" name="submit" value="(.*?)"|i');
			
			$img = $this->parser->parse_string($html, '|<img src="([^"]+)"|i');
			$img = $this->browser->get_page('http://google.com'.$img, '', false, true, true);
			
			$fname = LOG . '/' . get_uniq_id() . '.jpg';
			file_put_contents($fname, $img);
			
			$anticaptcha = new Anticaptcha();
			$response = $anticaptcha->recognize($fname, $this->gate_api, false, $settings->antigate_source.'.com', 5, 120, 0, 0, 0, 0, 0, 1);
			
			unlink($fname);
			
			$html = $this->browser->get_page('http://google.com/sorry/Captcha?continue='.urlencode("http://www.google.com/search?oe=utf8&ie=utf8&source=uds&start=0&hl=en&q=$query").'&id='.$id.'&captcha='.$response.'&submit='.urlencode($submit));
			$html = $this->browser->get_page("http://www.google.com/search?oe=utf8&ie=utf8&source=uds&start=0&hl=en&q=$query", '',false, false, false, true);
			
		}
		
		$result = $this->parser->get_div_content($html, '<div id=resultStats>');
		if ( !$result ) $result = $this->parser->get_div_content($html, '<div id="resultStats">');
		if ( !$result ) $result = $this->parser->get_div_content($html, '<div class="sd" id="resultStats">');
		
		$result = strip_tags($result);
		$result = str_replace(array('&#160;', ','), '', $result);
		$result = preg_replace('|\(.*?\)|', '', $result);
		$result = preg_replace('|[^\d,]|', '', $result);
		
		return $result;
	}
	
	public function get_yandex($site) {
		if ( $this->ya_xml ) return $this->get_yandex_by_xml($site);
		global $settings;
		
		$site = str_replace(array('http://', 'https://', '/', 'www.', ' '), '', $site);
		$query = "url:www.$site/* | url:$site/* | url:$site | url:www.$site";
		
		$html = $this->browser->get_page('http://yandex.ru/yandsearch?text='.urlencode($query));
		
		if($this->use_proxy){
			for($i=0; $i <= 5; $i++) {
				if ( !$html || strpos($html, 'Яндекс')===false || strpos($html, '<title>403')!==false || strpos($html, '<title>Ой')!==false ){
					if ( $i > 1 ) sleep(3);
					$html = $this->browser->get_page('http://yandex.ru/yandsearch?text='.urlencode($query));
				}
			}
		}
			
		if ( strpos($html, '<title>Ой!</title>')!==false ) {
			
			$key = $this->parser->parse_string($html, '|name="key" value="(.*?)"|i');
			$retpath = $this->parser->parse_string($html, '|name="retpath" value="(.*?)"|i');
			
			$img = $this->parser->parse_string($html, '|<img src="([^"]+)" class="b-captcha__image">|');
			if ( !$img ) $img = $this->parser->parse_string($html, '|<img class="image form__captcha"[^>]*src="(.*?)"|i');
			
			$img = $this->browser->get_page($img, '', true, true, true);
			if ( !$this->use_proxy )
				$exp = "Connection: close\r\n\r\n";
			else
				$exp = "Connection: keep-alive\r\n\r\n";
			@list($header, $body) = explode($exp, $img, 2);
			$img = $body;
			
			$fname = LOG . '/' . get_uniq_id() . '.jpg';
			file_put_contents($fname, $img);
			
			$anticaptcha = new Anticaptcha();
			$response = $anticaptcha->recognize($fname, $this->gate_api, false, $settings->antigate_source.'.com', 5, 120, 0, 0, 0, 0, 0, 1);
			
			unlink($fname);
			
			$html = $this->browser->get_page('http://yandex.ru/checkcaptcha?rep='.urlencode($response).'&key='.urlencode($key).'&retpath='.urlencode($retpath));
		}
		
		$result = $this->parser->parse_string($html, '|Яндекс: наш(.*?)ответ|i');
		if ( !$result ) $result = $this->parser->get_tags_by_class($html, 'strong', 'b-head-logo__text', true);
		if ( !$result ) $result = $this->parser->get_tags_by_class($html, 'span', 'input__found-text', true);
		
		$result = str_replace(array('тыс', 'млн'), array('000', '000000'), $result);
		
		$ya['index'] = preg_replace('|[^\d]|', '', $result);
		if ( !$ya['index'] ) $ya['index'] = 0;
		
		if($settings->sba_api){
			$ya['virus'] = $this->browser->get_page('https://sba.yandex.net/lookup?client=api&apikey=' . $settings->sba_api . '&pver=3.5&url=http://' . $site);
			if( strlen($ya['virus']) > 30 ) $ya['virus'] = '';
		}
		
		$ya['adalt'] = $this->browser->get_page('https://sba.yandex.net/cp?client=api&pver=4.0&url=http://' . $site);
		if( strlen($ya['adalt']) > 30 ) $ya['adalt'] = '';
		
		if( !$ya['virus'] && ( stripos($html, 'Будьте осторожны при скачивании файлов на этом сайте') || stripos($html, 'Сайт может угрожать безопасности вашего компьютера или мобильного устройства') ) ){
				$ya['virus'] = 'index warn';
		}
		
		return $ya;
	}
	
	public function get_yandex_by_xml($site) {
		global $settings;
		
		$site = str_replace(array('http://', 'https://', '/', 'www.', ' '), '', $site);
		
		$query = "url:www.$site/* | url:$site/* | url:$site | url:www.$site";
		
		/*
		$xml = new SimpleXMLElement("<?xml version='1.0' encoding='utf-8'?><request></request>");
		$xml->addChild('query', $query);
        $xml->addChild('page',  0);
		$groupings = $xml->addChild('groupings');
        $groupby = $groupings->addChild('groupby');
        $groupby->addAttribute('attr', '');
        $groupby->addAttribute('mode', 'flat');
        $groupby->addAttribute('groups-on-page', 50);
        $groupby->addAttribute('docs-in-group',  1);
        $groupby->addAttribute('curcateg',  -1);
		$xml->addChild('maxpassages', 5);
        $xml->addChild('max-title-length', 160);
        $xml->addChild('max-headline-length', 160);
        $xml->addChild('max-passage-length', 200);
        $xml->addChild('max-text-length', 640);
        
        $xml = $this->browser_ya_xml->get_page($this->ya_xml, $xml->asXML());
		*/
		
		$query = urlencode($query);
		$url = $this->ya_xml . "&query={$query}";
		
		$xml = $this->browser_ya_xml->get_page($url);
		
		
		$response = new SimpleXMLElement($xml);
		$response = $response->response;
		
		if ( isset($response->found[2]) ) $ya['index'] = (int)$response->found[2];
		if ( isset($response->found[1]) ) $ya['index'] = (int)$response->found[1];
		if ( isset($response->found[0]) ) $ya['index'] = (int)$response->found[0];
		
		if($settings->sba_api){
			$ya['virus'] = $this->browser->get_page('http://sba.yandex.net/lookup?client=api&apikey=' . $settings->sba_api . '&pver=3.5&url=http://' . $site);
			if( strlen($ya['virus']) > 30 ) $ya['virus'] = '';
		}
		
		$ya['adalt'] = $this->browser->get_page('http://sba.yandex.net/cp?client=api&pver=4.0&url=http://' . $site);
		if( strlen($ya['adalt']) > 30 ) $ya['adalt'] = '';
		
		return $ya;
	}
	
	public function get_yandex_video($site) {
		$site = str_replace(array('http://', 'https://', '/', ' '), '', $site);
		$query = "url:www.$site/* | url:$site/* | url:$site | url:www.$site";
		
		$html = $this->browser->get_page('http://yandex.ru/video/search?text='.urlencode($query));
		
		if($this->use_proxy){
			for($i=0; $i <= 5; $i++) {
				if ( !$html || strpos($html, 'Яндекс')===false || strpos($html, '<title>403')!==false || strpos($html, '<title>Ой')!==false ){
					if ( $i > 1 ) sleep(3);
					$html = $this->browser->get_page('http://yandex.ru/video/search?text='.urlencode("site:$site"));
				}
			}
		}
		
		if ( strpos($html, '<title>Ой!</title>')!==false ) {
			$key = $this->parser->parse_string($html, '|name="key" value="(.*?)"|i');
			$retpath = $this->parser->parse_string($html, '|name="retpath" value="(.*?)"|i');
				
			$img = $this->parser->parse_string($html, '|<img src="([^"]+)" class="b-captcha__image">|');
			if ( !$img ) $img = $this->parser->parse_string($html, '|<img class="image form__captcha"[^>]*src="(.*?)"|i');
			
			$img = $this->browser->get_page($img, '', true, true, true);
			if ( !$this->use_proxy )
				$exp = "Connection: close\r\n\r\n";
			else
				$exp = "Proxy-Connection: keep-alive\r\n\r\n";
			@list($header, $body) = explode($exp, $img, 2);
			$img = $body;
				
			$fname = LOG . '/' . get_uniq_id() . '.jpg';
			file_put_contents($fname, $img);
			
			$anticaptcha = new Anticaptcha();
			$response = $anticaptcha->recognize($fname, $this->gate_api, false, $settings->antigate_source.'.com', 5, 120, 0, 0, 0, 0, 0, 1);
				
			unlink($fname);
				
			$html = $this->browser->get_page('http://yandex.ru/checkcaptcha?rep='.urlencode($response).'&key='.urlencode($key).'&retpath='.urlencode($retpath));
		}
		$html = htmlspecialchars_decode($html);
		
		$result = $this->parser->parse_string($html, '|"foundNum":"([\d\s]+)"|');
		if ( !$result ) $result = $this->parser->parse_string($html, '|mdash;(.*?)видео"|i');
		if ( !$result ) $result = $this->parser->parse_string($html, '|\("\—(.*?). видео"\)|i');
		if ( !$result ) $result = $this->parser->parse_string($html, '|foundValue\\\u0022:\\\u0022—(.*?)видео|i');
		if ( !$result ) $result = $this->parser->parse_string($html, '|<div class="input__found">(.*?)</div>|i');
		
		$result = str_replace(array('тыс', 'млн'), array('000', '000000'), $result);
		$result = preg_replace('|[^\d]|', '', $result);
		
		if ( !$result ) $result = 0;
		return $result;
	}
	
	public function get_mail($site) {
		global $settings;
		$site = str_replace(array('http://', 'https://', '/', ' '), '', $site);
		$html = $this->browser->get_page("http://go.mail.ru/search?site=$site&advs=1&q=$site");
		
		if($this->use_proxy){
			for($i=0; $i <= 5; $i++) {
				if ( !$html || strpos($html, 'Mail.Ru')===false || strpos($html, 'Доступ к поисковой системе с вашего компьютера временно ограничен')!==false || strpos($html, 'Мы ограничили ваш доступ к Поиску')!==false ) {
					if ( $i > 1 ) sleep(3);
					$html = $this->browser->get_page("http://go.mail.ru/search?site=$site&advs=1&q=$site");
				}
			}
		}
		
		if ( strpos($html, 'Доступ к поисковой системе с вашего компьютера временно ограничен')!==false || strpos($html, 'Мы ограничили ваш доступ к Поиску')!==false ){
			$sqid = $this->parser->parse_string($html, '|name="sqid" value="(.*?)"|i');
			$img = 'http://go.mail.ru/ar_captcha?id='.$sqid;
			
			$img = $this->browser->get_page($img, '', true, true, true);
			
			if ( !$this->use_proxy )
				$exp = "X-Frame-Options: SAMEORIGIN\r\n\r\n";
				//$exp = "Connection: close\r\n\r\n";
			else
				$exp = "Connection: keep-alive\r\n\r\n";
			@list($header, $body) = explode($exp, $img, 2);
			$img = $body;
			
			$fname = LOG . '/' . get_uniq_id() . '.jpg';
			file_put_contents($fname, $img);
			
			$anticaptcha = new Anticaptcha();
			$response = $anticaptcha->recognize($fname, $this->gate_api, false, $settings->antigate_source.'.com', 5, 120, 0, 0, 0, 0, 0, 0);
			
			unlink($fname);
			
			$html = $this->browser->get_page('http://go.mail.ru/ar?sqid='.urlencode($sqid).'&SequreWord='.$response.'&q='.urlencode($site).'&back='.urlencode('http://go.mail.ru/search?site='.$site.'&advs=1&q='.$site));
		}
		
		$result = $this->parser->parse_string($html, '|foundCount: ([\d\s]+),|');
		
		if ( !$result ) $result = 0;
		return $result;
	}
	
	public function get_bing($site) {
		$site = str_replace(array('http://', 'https://', '/', ' '), '', $site);
		$html = $this->get_bing_page('site%3A'.$site);
		
		$result = $this->parser->parse_string($html, '|<span class="sb_count">(.*?)</span>|');
		$result = str_replace('&#160;', '', $result);
		$result = preg_replace('|[^\d]|', '', $result);
		$result = intval($result);
		
		return $result;
	}
	
	public function get_cy($site) {
		$site = str_replace(array('http://', 'https://', '/', ' '), '', $site);
		$url = 'http://bar-navig.yandex.ru/u?ver=2&show=32&url=http://'.$site.'/';

		$html = $this->browser->get_page($url);
		preg_match('/value="(.*)"/', $html, $tic);
		if($tic['1']!="") 
			$result=$tic['1'];
		else
			$result=0;

		return $result; 
	}
	
	
	protected function get_bing_page($query) {
		$header[] = 'Host: www.bing.com';
		$header[] = 'User-Agent: Mozilla/5.0 (Windows NT 6.1; rv:32.0) Gecko/20100101 Firefox/32.0';
		$header[] = 'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8';
		$header[] = 'Accept-Language: ru-RU,ru;q=0.8,en-US;q=0.5,en;q=0.3';
		$header[] = 'Accept-Encoding: none';
		$header[] = 'Referer: http://www.bing.com/';
		$header[] = 'Cookie: MUID=1C5788339A2B642519738E3A9E2B629B; OrigMUID=3E7DDD08F2E3674D01CBDB08F3C2670B%2cf9419990841b4701bb916b7d8f01ac64; SRCHD=MS=3265584&D=3265580&AF=NOFORM; SRCHUSR=AUTOREDIR=0&GEOVAR=&DOB=20140317; SRCHUID=V=2&GUID=BCBA76543C0143AB910A345453237B6C; _EDGE_V=1; MUIDB=1C5788339A2B642519738E3A9E2B629B; SRCHHPGUSR=CW=1903&CH=694; _HOP=; _SS=SID=BBFB0DC996A14315A5874F0F28755C15&bIm=433567; SCRHDN=ASD=0&DURL=#; WLS=TS=63548208587';
		$header[] = 'Connection: keep-alive';

		$url='http://www.bing.com/search?q='.$query.'&go=%D0%9E%D1%82%D0%BF%D1%80%D0%B0%D0%B2%D0%B8%D1%82%D1%8C+%D0%B7%D0%B0%D0%BF%D1%80%D0%BE%D1%81&qs=bs&form=QBRE';
		
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL,$url);
		curl_setopt($ch, CURLOPT_HEADER, 1);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
		curl_setopt($ch, CURLOPT_TIMEOUT, 30);
		curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt ( $ch , CURLOPT_HTTPHEADER , $header);
		$result = curl_exec($ch);
		curl_close($ch);
		
		return $result;
	}
	

	//Гугл он такой
	private function StrToNum($Str, $Check, $Magic) {
	    $Int32Unit = 4294967296; 

	    $length = strlen($Str); 
	    for ($i = 0; $i < $length; $i++) { 
	        $Check *= $Magic;      
	        if ($Check >= $Int32Unit) { 
	            $Check = ($Check - $Int32Unit * (int) ($Check / $Int32Unit)); 
	            $Check = ($Check < -2147483648) ? ($Check + $Int32Unit) : $Check; 
	        } 
	        $Check += ord($Str{$i});  
	    } 
	    return $Check; 
	} 

	private function HashURL($String) {
	    $Check1 = $this->StrToNum($String, 0x1505, 0x21); 
	    $Check2 = $this->StrToNum($String, 0, 0x1003F); 

	    $Check1 >>= 2;      
	    $Check1 = (($Check1 >> 4) & 0x3FFFFC0 ) | ($Check1 & 0x3F); 
	    $Check1 = (($Check1 >> 4) & 0x3FFC00 ) | ($Check1 & 0x3FF); 
	    $Check1 = (($Check1 >> 4) & 0x3C000 ) | ($Check1 & 0x3FFF);     
	     
	    $T1 = (((($Check1 & 0x3C0) << 4) | ($Check1 & 0x3C)) <<2 ) | ($Check2 & 0xF0F ); 
	    $T2 = (((($Check1 & 0xFFFFC000) << 4) | ($Check1 & 0x3C00)) << 0xA) | ($Check2 & 0xF0F0000 ); 
	     
	    return ($T1 | $T2); 
	} 

	private function CheckHash($Hashnum) {
	    $CheckByte = 0; 
	    $Flag = 0; 

	    $HashStr = sprintf('%u', $Hashnum) ; 
	    $length = strlen($HashStr); 
	     
	    for ($i = $length - 1;  $i >= 0;  $i --) { 
	        $Re = $HashStr{$i}; 
	        if (1 === ($Flag % 2)) {               
	            $Re += $Re;      
	            $Re = (int)($Re / 10) + ($Re % 10); 
	        } 
	        $CheckByte += $Re; 
	        $Flag ++;     
	    } 

	    $CheckByte %= 10; 
	    if (0 !== $CheckByte) { 
	        $CheckByte = 10 - $CheckByte; 
	        if (1 === ($Flag % 2) ) { 
	            if (1 === ($CheckByte % 2)) { 
	                $CheckByte += 9; 
	            } 
	            $CheckByte >>= 1; 
	        } 
	    } 

	    return '7'.$CheckByte.$HashStr; 
	} 

	public function get_pr($url) {
		$url = str_replace(array('http://', 'https://', '/', ' '), '', $url);

		$googlehost='toolbarqueries.google.com'; 
		$googleua='Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.0.6) Gecko/20060728 Firefox/1.5';

		$hash = $this->HashURL($url);
	    $ch = $this->CheckHash($hash); 

	    $fp = fsockopen($googlehost, 80, $errno, $errstr, 30); 
	    if ($fp) { 
	       //$out = "GET /search?client=navclient-auto&ch=$ch&features=Rank&q=info:$url HTTP/1.1\r\n"; 
	       $out = "GET /tbr?features=Rank&sourceid=navclient-ff&client=navclient-auto-ff&ch=$ch&q=info:$url HTTP/1.1\r\n";
	       $out .= "User-Agent: $googleua\r\n"; 
	       $out .= "Host: $googlehost\r\n"; 
	       $out .= "Connection: Close\r\n\r\n"; 
	     
	       fwrite($fp, $out); 
	       while (!feof($fp)) { 
	            $data = fgets($fp, 128); 
	            $pos = strpos($data, "Rank_"); 
	            if($pos === false){} else{ 
	                $pr=substr($data, $pos + 9); 
	                $pr=trim($pr); 
	                $pr=str_replace("\n",'',$pr); 
	                return $pr; 
	            } 
	       } 
	       fclose($fp); 
	    }
		
		return 0;
	}
	
	// яндекс.метрика
	public function get_yam_counters() {
		global $settings;
		$token = $settings->yam_token;
		
		if ( !$token ) return array();
		
		$counters = file_get_contents("http://api-metrika.yandex.ru/counters.json?oauth_token={$token}");
		$counters = json_decode($counters, true);
		
		$result = array();
		
		foreach ($counters['counters'] as $row)
			$result[ $row['site'] ] = $row;
		
		return $result;
	}
	
	public function get_yam_stat($counter_id) {
		global $settings;
		$token = $settings->yam_token;
		
		$stat = array(
			'today_visitors' => 0,
			'today_visitors_diff' => 0,
			
			'today_hits' => 0,
			'today_hits_diff' => 0,
				
			'yesterday_visitors' => 0,
			'yesterday_hits' => 0,
		);
		
		if ( !$token ) return $stat;
		
		$today = date('Ymd');
		$yesterday = date('Ymd', time()-86400);
		
		$data = file_get_contents("http://api-metrika.yandex.ru/stat/traffic/summary.json?id={$counter_id}&date1={$yesterday}&date2={$today}&group=day&oauth_token={$token}");
		$data = json_decode($data);
		
		foreach( $data->data as $row ){
			if( $row->date == $today){
				$stat['today_visitors'] = $row->visitors;
				$stat['today_hits'] = $row->page_views;
			}
			if( $row->date == $yesterday){
				$stat['yesterday_visitors'] = $row->visitors;
				$stat['yesterday_hits'] = $row->page_views;
			}
		}
		
		return $stat;
	}
	
	public function get_yam_ps_stat($counter_id) {
		global $settings;
		$token = $settings->yam_token;
		
		$stat = array();
		
		if ( !$token ) return $stat;
		
		$today = date('Ymd');
		$yesterday = date('Ymd', time()-86400);
		
		$data = file_get_contents("https://api-metrika.yandex.ru/stat/v1/data/bytime?preset=search_engines&dimensions=ym:s:<attribution>SearchEngineRoot&metrics=ym:s:visits&group=day&id={$counter_id}&date1={$yesterday}&date2={$today}&oauth_token={$token}");
		$data = json_decode($data);
		// Яндекс
		// Google
		// Mail.ru
		// Bing
		foreach( $data->data as $row ){
			$stat[] = array(
				'ps' => $row->dimensions[0]->name,
				'today' => $row->metrics[0][1],
				'yesterday' => $row->metrics[0][0],
			);
		}
		
		return $stat;
	}
	
	public function get_yam_wap_stat($counter_id) {
		global $settings;
		$token = $settings->yam_token;
		
		$stat = array(
			'today' => 0,
			'yesterday' => 0
		);
		
		if ( !$token ) return $stat;
		
		$today = date('Ymd');
		$yesterday = date('Ymd', time()-86400);
		
		$data = file_get_contents("http://api-metrika.yandex.ru/stat/tech/mobile.json?id={$counter_id}&date1={$today}&date2={$today}&group=day&oauth_token={$token}");
		$data = json_decode($data);
		$todays = $data->totals->visits;
		$stat['today'] = ($todays) ? $todays : '0';
		
		$data = file_get_contents("http://api-metrika.yandex.ru/stat/tech/mobile.json?id={$counter_id}&date1={$yesterday}&date2={$yesterday}&group=day&oauth_token={$token}");
		$data = json_decode($data);
		$yester = $data->totals->visits;
		$stat['yesterday'] = ($yester) ? $yester : '0';
		
		return $stat;
	}
	
	public function get_yam_month_stat($counter_id){
		global $settings;
		$token = $settings->yam_token;
		
		$today = date('Ymd');
		$yesterday = date('Ymd', time()-31536000);
		
		$data = file_get_contents("http://api-metrika.yandex.ru/stat/traffic/summary.json?id={$counter_id}&date1={$yesterday}&date2={$today}&group=month&oauth_token={$token}");
		$data = json_decode($data);
		
		foreach($data->data as $month){
			$stat[] = array(
				'date' => date('M y', strtotime($month->date)),
				'hits' => $month->page_views,
				'visitors' => $month->visits
			);
		}
		
		return json_encode($stat);
	}
	
	public function get_yam_key($counter_id, $start, $end) {
		global $settings;
		$token = $settings->yam_token;
		
		$start = date('Ymd',strtotime($start));
		$end = date('Ymd',strtotime($end));
		
		
		$results = file_get_contents("http://api-metrika.yandex.ru/stat/sources/phrases.json?id={$counter_id}&date1={$start}&date2={$end}&per_page=10000&oauth_token={$token}");
		$results = json_decode($results);
		
		foreach( $results->data as $row )
			$keys[] = $row->phrase;
		
		$total = ceil($results->rows / 10000);
		
		for($i=1; $i <= ($total-1); $i++) {
			$offset = (10000*$i)+1;
			$results = file_get_contents("http://api-metrika.yandex.ru/stat/sources/phrases.json?id={$counter_id}&date1={$start}&date2={$end}&per_page=10000&oauth_token={$token}&offset={$offset}");
			$results = json_decode($results);
			
			foreach( $results->data as $row )
				$keys[] = $row->phrase;
		}
		
		return $keys;
	}
	
	
	// google analytics
	public function get_ga_stat($ga_id) {
		global $settings;
		$token = $settings->ga_token;
		
		$stat = array(
			'today_visitors' => 0,
			'today_visitors_diff' => 0,
				
			'today_hits' => 0,
			'today_hits_diff' => 0,
	
			'yesterday_visitors' => 0,
			'yesterday_hits' => 0,
		);
		
		if ( !$token ) return $stat;
		
		$today = date('Y-m-d');
		$yesterday = date('Y-m-d', time()-86400);
		
		$client = new Google_Client();
		 
		$client->setClientId( $settings->ga_id );
		$client->setClientSecret( $settings->ga_secret );
		$client->setRedirectUri( 'http://' . $settings->host . '/ajax/ga.php' );
		$client->setDeveloperKey( $settings->ga_api_key );
		$client->setScopes( array('https://www.googleapis.com/auth/analytics.readonly', 'https://www.googleapis.com/auth/analytics') );
		$client->setAccessType('offline');
		$client->setApprovalPrompt('force');
		
		$oauth2 = new Google_Service_Oauth2($client);
		
		$client->setAccessToken( $settings->ga_token );
		
		$expired = $client->isAccessTokenExpired();
		if ( $expired ) {
			$client->refreshToken( $settings->ga_refresh_token );
			$settings->save_option('ga_token', $client->getAccessToken());
		}
		$analytics = new Google_Service_Analytics($client);
		
		$results = $analytics->data_ga->get( "ga:{$ga_id}", $today, $today, 'ga:sessions,ga:pageviews' );
		$rows = $results->rows;
		$stat['today_visitors'] = isset($rows[0][0]) ? $rows[0][0] : 0;
		$stat['today_hits'] = isset($rows[0][1]) ? $rows[0][1] : 0;
		
		$results = $analytics->data_ga->get( "ga:{$ga_id}", $yesterday, $yesterday, 'ga:sessions,ga:pageviews' );
		$rows = $results->rows;
		$stat['yesterday_visitors'] = isset($rows[0][0]) ? $rows[0][0] : 0;
		$stat['yesterday_hits'] = isset($rows[0][1]) ? $rows[0][1] : 0;
		
		return $stat;
	}
	
	public function get_ga_wap_stat($ga_id) {
		global $settings;
		$token = $settings->ga_token;
		
		$stat = array(
			'today' => 0,
			'yesterday' => 0
		);
		
		if ( !$token ) return $stat;
		
		$today = date('Y-m-d');
		$yesterday = date('Y-m-d', time()-86400);
		
		$client = new Google_Client();
			
		$client->setClientId( $settings->ga_id );
		$client->setClientSecret( $settings->ga_secret );
		$client->setRedirectUri( 'http://' . $settings->host . '/ajax/ga.php' );
		$client->setDeveloperKey( $settings->ga_api_key );
		$client->setScopes( array('https://www.googleapis.com/auth/analytics.readonly', 'https://www.googleapis.com/auth/analytics') );
		$client->setAccessType('offline');
		
		$oauth2 = new Google_Service_Oauth2($client);
		
		$client->setAccessToken( $settings->ga_token );
		
		$expired = $client->isAccessTokenExpired();
		if ( $expired ) {
			$client->refreshToken( $settings->ga_refresh_token );
			$settings->save_option('ga_token', $client->getAccessToken());
		}
		
		$analytics = new Google_Service_Analytics($client);
		
		$results = $analytics->data_ga->get( "ga:{$ga_id}", $today, $today, 'ga:sessions,ga:pageviews', array('dimensions' => 'ga:isMobile,ga:isTablet') );
		$rows = $results->rows;
		if ( !$rows ) $rows = array();
		
		foreach ($rows as $row)
			$stat['today'] += ($row[0] == 'Yes' || $row[1] == 'Yes') ? $row[2] : 0;
		
		$results = $analytics->data_ga->get( "ga:{$ga_id}", $yesterday, $yesterday, 'ga:sessions,ga:pageviews', array('dimensions' => 'ga:isMobile,ga:isTablet') );
		$rows = $results->rows;
		
		if ( !$rows ) $rows = array();
		foreach ($rows as $row)
			$stat['yesterday'] = ($row[0] == 'Yes') ? $row[2] : 0;
		
		return $stat;
	}
	
	public function get_ga_ps_stat($ga_id) {
		global $settings;
		$token = $settings->ga_token;
		
		$stat = $arr = $res = $result = $results = array();
		
		if ( !$token ) return $stat;
		
		$today = date('Y-m-d');
		$yesterday = date('Y-m-d', time()-86400);
		
		$client = new Google_Client();
		
		$client->setClientId( $settings->ga_id );
		$client->setClientSecret( $settings->ga_secret );
		$client->setRedirectUri( 'http://' . $settings->host . '/ajax/ga.php' );
		$client->setDeveloperKey( $settings->ga_api_key );
		$client->setScopes( array('https://www.googleapis.com/auth/analytics.readonly', 'https://www.googleapis.com/auth/analytics') );
		$client->setAccessType('offline');
		
		$oauth2 = new Google_Service_Oauth2($client);
		
		$client->setAccessToken( $settings->ga_token );
		
		$expired = $client->isAccessTokenExpired();
		if ( $expired ) {
			$client->refreshToken( $settings->ga_refresh_token );
			$settings->save_option('ga_token', $client->getAccessToken());
		}
		
		$analytics = new Google_Service_Analytics($client);
		
		$results = $analytics->data_ga->get( "ga:{$ga_id}", $yesterday, $today, 'ga:organicSearches', array('dimensions' => 'ga:source,ga:date') );
		$rows = $results->rows;
		
		$rows_today = date('Ymd');
		$rows_yesterday = date('Ymd', time()-86400);
		
		if ( !$rows ) $rows = array();
		
		foreach( $rows as $k => $v )
			$res[] = array('ps' => $v[0], 'name' => array($v[1] => $v[2]));
		
		foreach ($res as $l)
		  $result[$l['ps']][] = $l['name'];
		
		foreach ($result as $key => $val){
			$arr['ps'] = $key;
			$arr['today'] = 0;
			$arr['yesterday'] = 0;
			
			foreach($val as $ke => $va){
				foreach($va as $k => $v){
					if($k == $rows_today) $arr['today'] = $v;
					if($k == $rows_yesterday) $arr['yesterday'] = $v;
				}
			}
			// Яндекс
			// Google
			// Mail.ru
			// Bing
			$arr['ps'] = str_replace( array("yandex","google","go.mail.ru","bing"), array("Яндекс","Google","Mail.ru","Bing"), $arr['ps'] );
			
			$stat[] = $arr;
		}
  
		return $stat;
	}
		
	
	public function get_ga_month_stat($ga_id){
		global $settings;
		$token = $settings->ga_token;
		
		$stat = array();
		
		if ( !$token ) return $stat;
		
		$today = date('Y-m-d');
		$yesterday = date('Y-m-d', time()-31536000);
		
		$client = new Google_Client();
		
		$client->setClientId( $settings->ga_id );
		$client->setClientSecret( $settings->ga_secret );
		$client->setRedirectUri( 'http://' . $settings->host . '/ajax/ga.php' );
		$client->setDeveloperKey( $settings->ga_api_key );
		$client->setScopes( array('https://www.googleapis.com/auth/analytics.readonly', 'https://www.googleapis.com/auth/analytics') );
		$client->setAccessType('offline');
		$client->setApprovalPrompt('force');
		
		$oauth2 = new Google_Service_Oauth2($client);
		
		$client->setAccessToken( $settings->ga_token );
		
		$expired = $client->isAccessTokenExpired();
		if ( $expired ) {
			$client->refreshToken( $settings->ga_refresh_token );
			$settings->save_option('ga_token', $client->getAccessToken());
		}
		$analytics = new Google_Service_Analytics($client);
		
		$results = $analytics->data_ga->get( "ga:{$ga_id}", $yesterday, $today, 'ga:sessions,ga:pageviews', array('dimensions' => 'ga:yearMonth'));
		
		foreach($results->rows as $month){
			$stat[] = array(
				'date' => date('M y', strtotime($month[0].'01')),
				'hits' => $month[2],
				'visitors' => $month[1]
			);
		}
		
		return json_encode($stat);
	}
	
	public function get_ga_key($ga_id, $start, $end) {
		global $settings;
		$token = $settings->ga_token;
		
		if ( !$token ) return false;
		
		$client = new Google_Client();
		 
		$client->setClientId( $settings->ga_id );
		$client->setClientSecret( $settings->ga_secret );
		$client->setRedirectUri( 'http://' . $settings->host . '/ajax/ga.php' );
		$client->setDeveloperKey( $settings->ga_api_key );
		$client->setScopes( array('https://www.googleapis.com/auth/analytics.readonly', 'https://www.googleapis.com/auth/analytics') );
		$client->setAccessType('offline');
		$client->setApprovalPrompt('force');
		
		$oauth2 = new Google_Service_Oauth2($client);
		
		$client->setAccessToken( $settings->ga_token );
		
		$expired = $client->isAccessTokenExpired();
		if ( $expired ) {
			$client->refreshToken( $settings->ga_refresh_token );
			$settings->save_option('ga_token', $client->getAccessToken());
		}
		$analytics = new Google_Service_Analytics($client);
		
		# https://developers.google.com/analytics/devguides/reporting/core/dimsmets
		$params =  array(
						'dimensions'    => 'ga:keyword',
						'max-results'   => '10000',
						'start-index'   => '1',	
						);
		$results = $analytics->data_ga->get( "ga:{$ga_id}", $start, $end, 'ga:organicSearches', $params );
		foreach( $results->rows as $row )
			if($row[0] != '(not set)' && $row[0] != '(not provided)') $keys[] = $row[0];
		
		$total = ceil($results->totalResults / 10000);
		if( $total > 1 ){
			for($i=1; $i <= ($total-1); $i++) {
				$params['start-index'] = $i.'0000';
				$results = $analytics->data_ga->get( "ga:{$ga_id}", $start, $end, 'ga:organicSearches', $params );
				foreach( $results->rows as $row )
					if($row[0] != '(not set)' && $row[0] != '(not provided)') $keys[] = $row[0];
			}
		}
		
		return $keys;
	}
	
	public function get_ip($url){
		foreach(gethostbynamel($url) as $ip);
		return $ip;
	}
	
	public function get_domain_info($url){
		$url = str_replace(array('http://', 'https://', '/', ' '), '', $url);
		$mtime = microtime();
		$mtime = explode(" ",$mtime);
		$mtime = $mtime[1] + $mtime[0];
		$tstart = $mtime;
		
		$html = file_get_contents("http://$url");
		
		$mtime = microtime();
		$mtime = explode(" ",$mtime);
		$mtime = $mtime[1] + $mtime[0];
		$tend = $mtime;
		$totaltime = ($tend - $tstart);
		$info['time'] = round($totaltime,0);
		
		$string = $this->parser->parse_string($html, '|<title>(.*?)</title>|si');
		$charset = detect_encoding($string);
		if ( $charset == 'windows-1251' ) $string = ic_wu($string);
		$info['title'] = $string;
		
		$info['header'] = $this->parser->parse_string($http_response_header['0'], '!\s(.*?)\s!si');
		
		return $info;
	}
	
	public function get_whois($url){
		$url = str_replace(array('http://', 'https://', '/', ' '), '', $url);
		$file = $this->browser->get_page("http://4or6.com/whois.php", "q=$url");
		
		if($this->use_proxy){
			for($i=0; $i <= 5; $i++) {
				if ( !$file  || strpos($file, 'IPv6 Traceroute Server')===false ){
					if ( $i > 1 ) sleep(3);
					$file = $this->browser->get_page("http://4or6.com/whois.php", "q=$url");
				}
			}
		}
		
		$whois = array(
					'whois_created' => '',
					'whois_paid' => '',
					'reg' => '',
				);
		
		if(strpos($url, '.ru')!==false){
			$created = $this->parser->parse_string($file, '|created:\s+(.*?)\n|i');
			$paid = $this->parser->parse_string($file, '|paid-till:\s+(.*?)\n|i');
			$whois['reg'] = $this->parser->parse_string($file, '|registrar:\s+(.*?)\n|i');
		}
		elseif(strpos($url, '.mobi')!==false){
			$created = $this->parser->parse_string($file, '|Created On:(.*?)\n|i');
			$paid = $this->parser->parse_string($file, '|Expiration Date:(.*?)\n|i');
		}
		//elseif(strpos($url, '.org.ua')!==false || strpos($url, '.com.ua')!==false){
		//	$created = $this->parser->parse_string($file, '|created:\s+(.*?)\n|i');
		//	$paid = $this->parser->parse_string($file, '|expires:\s+(.*?)\n|i');
		//	$whois['reg'] = $this->parser->parse_string($file, '|registrar:\s+(.*?)\n|s');
		//}
		elseif(strpos($url, '.ua')!==false){
			$created = $this->parser->parse_string($file, '|created:\s+(.*?)\n|i');
			$paid = $this->parser->parse_string($file, '|expires:\s+(.*?)\n|i');
			$whois['reg'] = $this->parser->parse_string($file, '|registrar:\s+(.*?)\n|s');
		}
		elseif(strpos($url, '.org')!==false || strpos($url, '.tv')!==false || strpos($url, '.info')!==false || strpos($url, '.xyz')!==false){
			$created = $this->parser->parse_string($file, '|Creation Date:\s+(.*?)\n|i');
			$paid = $this->parser->parse_string($file, '|Registry Expiry Date:(.*?)\n|i');
		}
		elseif(strpos($url, '.biz')!==false){
			$created = $this->parser->parse_string($file, '|Domain Registration Date:\s+(.*?)\n|i');
			$paid = $this->parser->parse_string($file, '|Domain Expiration Date:(.*?)\n|i');
			$whois['reg'] = $this->parser->parse_string($file, '|Created by Registrar:\s+(.*?)\n|i');
		}
		else{
			$created = $this->parser->parse_string($file, '|Creation Date:\s+(.*?)\n|i');
			$paid = $this->parser->parse_string($file, '|Expiration Date:\s+(.*?)\n|i');
			$whois['reg'] = $this->parser->parse_string($file, '|registrar:\s+(.*?)\n|i');
		}
		
		if($created) $whois['whois_created'] = date( 'd.m.Y', strtotime(str_replace('.', '-', $created)));
		if($paid) $whois['whois_paid'] = date( 'd.m.Y', strtotime(str_replace('.', '-', $paid)));
		
		return $whois;
	}
	
	public function get_promosite(){
		$xml = $this->browser->get_page("http://api.promosite.ru/public/yabar.xml");
		$response = new SimpleXMLElement($xml);
		$array = (array) $response->mainbutton->tooltip;
		if(!$array[0]) $array[0] = '';
		
		return $array[0];
	}
	
	public function get_antizapret($site) {
		$site = str_replace(array('http://', 'https://', '/', 'www.', ' '), '', $site);
		
		$json = $this->browser->get_page("https://api.antizapret.info/get.php?item=$site&type=json");
		$data = json_decode($json);
		
		if($data->register) return 'Фильтр Роскомнадзора';
		
		return false;
	}
}
